GTPin: GTReplay: Kernel ASM traverse API

GTPin

- Main Page
- Related Pages
- Modules
- Data Structures

Functions
GTReplay: Kernel ASM traverse API

A group of GTReplay APIs intended for traversing and inspection of the kernel's control flow graph (CFG) elements More...

## Functions
GTREPLAY_API uint32_t | GTReplay_GetKernelEntryAddress (GTReplayKernel kernel)
GTREPLAY_API GTReplayBbl | GTReplay_BblHead (GTReplayKernel kernel)
GTREPLAY_API GTReplayBbl | GTReplay_BblNext (GTReplayBbl bbl)
GTREPLAY_API bool | GTReplay_BblValid (GTReplayBbl bbl)
GTREPLAY_API GTReplayIns | GTReplay_InsHead (GTReplayBbl bbl)
GTREPLAY_API GTReplayIns | GTReplay_InsTail (GTReplayBbl bbl)
GTREPLAY_API GTReplayIns | GTReplay_InsNext (GTReplayIns ins)
GTREPLAY_API GTReplayIns | GTReplay_InsPrev (GTReplayIns ins)
GTREPLAY_API bool | GTReplay_InsValid (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_BblId (GTReplayBbl bbl)
GTREPLAY_API GTReplayIns | GTReplay_Ins (GTReplayKernel kernel, uint32_t id)
GTREPLAY_API uint32_t | GTReplay_InsId (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_BblIdFromIns (GTReplayIns ins)
GTREPLAY_API GTReplayKernel | GTReplay_Kernel (GTReplayIns ins)
GTREPLAY_API uint32_t | GTReplay_NumOfInstructions (GTReplayKernel kernel)

## Detailed Description

A group of GTReplay APIs intended for traversing and inspection of the kernel's control flow graph (CFG) elements

## Function Documentation

GTREPLAY_API GTReplayBbl GTReplay_BblHead | ( | GTReplayKernel | kernel | ) |

Returns:
  a handle to the head basic block of the kernel

Parameters:

  [in] | kernel | the target kernel.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_BblId | ( | GTReplayBbl | bbl | ) |

Return the ID of the given basic block

Parameters:

  [in] | bbl | the basic block handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_BblIdFromIns | ( | GTReplayIns | ins | ) |

Returns:
  the ID of the corresponding basic block from given instruction

Parameters:

  [in] | ins | the instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API GTReplayBbl GTReplay_BblNext | ( | GTReplayBbl | bbl | ) |

Returns:
  a handle to the next basic block after bbl

Parameters:

  [in] | bbl | the target basic block handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_BblValid | ( | GTReplayBbl | bbl | ) |

Check whether the basic block handle is valid

Returns:
  TRUE if a given basic block is valid and FALSE otherwise

Parameters:

  [in] | bbl | the basic block handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_GetKernelEntryAddress | ( | GTReplayKernel | kernel | ) |

Returns:
  32-bit entry address of the kernel

Parameters:

  [in] | kernel | the target kernel.

Availability:
  - OnKernelBuild

GTREPLAY_API GTReplayIns GTReplay_Ins | ( | GTReplayKernel | kernel,
|  | uint32_t | id
| ) |  |

Returns:
  instruction handle from id

Parameters:

  [in] | kernel | a kernel handle
  [in] | id | id of the instruction

Availability:
  - OnKernelBuild

GTREPLAY_API GTReplayIns GTReplay_InsHead | ( | GTReplayBbl | bbl | ) |

Returns:
  a handle to the head instruction of the basic block

Parameters:

  [in] | bbl | the basic block handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_InsId | ( | GTReplayIns | ins | ) |

Returns:
  the ID of the given instruction

Parameters:

  [in] | ins | the instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API GTReplayIns GTReplay_InsNext | ( | GTReplayIns | ins | ) |

Returns:
  a handle to the next instruction after ins

Parameters:

  [in] | ins | the instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API GTReplayIns GTReplay_InsPrev | ( | GTReplayIns | ins | ) |

Returns:
  a handle to the instruction before ins in the same bbl

Parameters:

  [in] | ins | the instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API GTReplayIns GTReplay_InsTail | ( | GTReplayBbl | bbl | ) |

Returns:
  a handle to the tail instruction of the basic block

Parameters:

  [in] | bbl | the basic block handle.

Availability:
  - OnKernelBuild

GTREPLAY_API bool GTReplay_InsValid | ( | GTReplayIns | ins | ) |

Check whether the instruction handle is valid

Returns:
  TRUE if a given instrcution is valid and FALSE otherwise

Parameters:

  [in] | ins | the instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API GTReplayKernel GTReplay_Kernel | ( | GTReplayIns | ins | ) |

Returns:
  kernel handle from given instruction

Parameters:

  [in] | ins | the instruction handle.

Availability:
  - OnKernelBuild

GTREPLAY_API uint32_t GTReplay_NumOfInstructions | ( | GTReplayKernel | kernel | ) |

Returns:
  the amount of instructions within given kernel

Parameters:

  [in] | kernel | a kernel handle

Availability:
  - OnKernelBuild

All Data Structures Functions Variables Typedefs Enumerations Enumerator

      Copyright (C) 2013-2025 Intel Corporation

      SPDX-License-Identifier: MIT